/*
 * printdata.c
 *
 * Prints the data stored in the array of structs newsector to the file
 * X.tml where X is the original data file name
 * 
 * Copyright (c) 1983 Bertil K Jonell 
 *
 */

#include<stdio.h>
#include<strings.h>
#include<ctype.h>
#include"include.h"

char *port_types[6]={
	"A", "B", "C", "D", "E", "X"
	};

char *base_types[17]={
	" ", "S", "W", " ", "N", "A", "B", " ", "D", " ", " ", " ", " ",
	" ", " ", " ", "M"
	};

char *zone_types[3]={
	" ", "A", "R"
	};

extern struct system newsector[][40];

void present(file)
char file[];
{
  char tne_file[MAXSTR];
  int i, j;
  FILE *f1, *fopen();
  char n2h();

  strncpy(tne_file, file, strlen(file) - 3);
  tne_file[strlen(file)-3] = (char)NULL;
  strcat(tne_file, "tne");


  if ((f1 = fopen(tne_file, "w")) == NULL) {
    fprintf(stderr, "I can't open %s\n", tne_file);
    exit(1);
  }

  fprintf(stderr, "%s\n", tne_file);

  for(i=0; i < 32; i++) {
    for(j=0; j < 40; j++) {
      if (newsector[i][j].presence) {
	fprintf(f1, 
  "%-14.14s%02d%02d %c%c%c%c%c%c%c-%c  %c %-15.15s %c  %d%d%d %2s %-16.16s\n",
	  newsector[i][j].name, i+1, j+1,
	  *port_types[newsector[i][j].port],
	  n2h(newsector[i][j].size),
	  n2h(newsector[i][j].atm),
	  n2h(newsector[i][j].hyd),
	  n2h(newsector[i][j].pop),
	  n2h(newsector[i][j].gov),
	  n2h(newsector[i][j].law),
	  n2h(newsector[i][j].tech),
	  *base_types[newsector[i][j].base],
	  newsector[i][j].trade,
	  *zone_types[newsector[i][j].zone],
	  newsector[i][j].popmul,newsector[i][j].plan,newsector[i][j].gas,
	  newsector[i][j].alle,
	  newsector[i][j].stars);
      }
    }
  }
  fclose(f1);
}


char n2h(i)
int i;
{
  if (i > 17) i++;
  if (i > 9) return ((char)(i + 55));
  return ((char)(i + 48));
}
