/*
 * readdata.c
 * 
 * Reads the datafile created by Sec that determines how to treat the
 * sector file and puts in in the global array of structs sector
 * 
 * Copyright (c) 1993 Bertil K Jonell 
 *
 */

#include<stdio.h>
#include<strings.h>
#include<ctype.h>
#include"include.h"

static struct system empty = {
	FALSE,
	"              ",
	0, 0, 0, 0, 0, 0, 0, 0,
	0,
	"               ",
	0,
	0, 0, 0,
	"  ",
	"                ",
	0, 0
	};

extern struct system sector[][40];

void read_area_data(file)
char file[];
{
  char s[MAXSTR];
  char area_file[MAXSTR];
  FILE *f1, *fopen();
  void store_area_data();

  strncpy(area_file, file, strlen(file) - 3);
  area_file[strlen(file)-3] = (char)NULL;
  strcat(area_file, "dat");

  fprintf(stderr, "%s\n", area_file);

  if ((f1 = fopen(area_file, "r")) == NULL) {
    fprintf(stderr, "I can't open %s\n", area_file);
    exit(1);
  }

  while (fgets(s, sizeof(s), f1) != NULL) {
    store_area_data(s);
  }
  fclose(f1);
}


store_area_data(s)
char s[];
{
  int test;
  int xhex, yhex, area, war;

  if((test = sscanf(s, "%d %d %d %d", &xhex, &yhex, &war, &area)) != 4) {
    fprintf(stderr, "Error reading area data file: %s\n  %d %d %d %d\n", s, xhex, yhex, war, area);
    return;
  } else {
    sector[xhex-1][yhex-1] = empty;
    sector[xhex-1][yhex-1].area = area;
    sector[xhex-1][yhex-1].war = war;
  }
}
